
#include "PublicSDKMotion.h"


class TestGame : public PublicSDKMotion
{
public:
	TestGame();


	virtual void Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
		int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
		int jump, int down, int rssi);

private:

	 deque<int> left_acc_deque;
	 deque<int> right_acc_deque;
	 int jump_valid_time;
	 int jump_calm_down;

	 int last_jump;

};