#include "JumpHouse.h"

JumpHouse::JumpHouse()
{
	left_init = 0;
	right_init = 0;

	left_heading = 0;
	right_heading = 0;

	for (int i = 1; i < 3; i++)
	{
		for (int k = 0; k < 3; k++)
		{
			left_acc_buff[i ][k] = 0;
			right_acc_buff[i ][k] = 0;
		}
	}


}

bool JumpHouse::unzuptValid(int* max_acc, int* min_acc)
{
	if ((max_acc[0] - min_acc[0] > 2048 || max_acc[1] - min_acc[1] > 2048 || max_acc[2] - min_acc[2] > 2048) && min_acc[0] < 500)
	{

		return true;
	}

	return false;
}


void JumpHouse::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{

	//̽Ϊڵ
	// 

	if (has_init == 0)
	{
		rssi_vec.push_back(rssi);
		pitch_vec.push_back(left_att[1] - right_att[1]);
		roll_vec.push_back((left_att[2] + right_att[2]) * 0.5f);
		left_acc_vec.push_back(sqrt(left_acc[0] * left_acc[0] + left_acc[1] * left_acc[1] + left_acc[2] * left_acc[2]));
		right_acc_vec.push_back(sqrt(right_acc[0] * right_acc[0] + right_acc[1] * right_acc[1] + right_acc[2] * right_acc[2]));


		if (rssi_vec.size() > 50)
		{
			rssi_vec.pop_front();
			pitch_vec.pop_front();
			roll_vec.pop_front();
			left_acc_vec.pop_front();
			right_acc_vec.pop_front();
		}

		if (rssi_vec.size() == 50)
		{
			int max_rssi = *max_element(rssi_vec.begin(), rssi_vec.end());
			int left_max_acc = *max_element(left_acc_vec.begin(), left_acc_vec.end());
			int left_min_acc = *min_element(left_acc_vec.begin(), left_acc_vec.end());

			int right_max_acc = *max_element(right_acc_vec.begin(), right_acc_vec.end());
			int right_min_acc = *min_element(right_acc_vec.begin(), right_acc_vec.end());

			if (max_rssi < 25 && left_max_acc - left_min_acc < 510 && right_max_acc - right_min_acc < 510)
			{
				for (int i = 0; i < 50; i++)
				{
					pitch_reference_val += pitch_vec[i];
					roll_reference_val += pitch_vec[i];
				}
				pitch_reference_val /= 50;
				roll_reference_val /= 50;

				std::cout << "init roll and pitch  !!!!" << endl;
			}

		}

	}
	if (left_zupt == 1 && left_att[1] * 0.0001f > 0.5f)
	{
		std::cout << "if (left_zupt == 1 && left_att[1] * 0.0001f > 0.6f) " << left_att[1] * 0.0001f <<  endl;
		left_zupt = 0;
	}
	if (right_zupt == 1 && right_att[1] * 0.0001f > 0.5f)
	{
		std::cout << "if (right_zupt == 1 && right_att[1] * 0.0001f > 0.6f) " << right_att[1] * 0.0001f << endl;
		right_zupt = 0;
	}

	if (left_zupt)
	{
		left_zupt_extension_time = 5;
	}

	if (right_zupt)
	{
		right_zupt_extension_time = 5;
	}

	if (left_zupt_extension_time > 0)
	{
		left_zupt = 1;

		left_zupt_extension_time--;
	}

	if (right_zupt_extension_time > 0)
	{
		right_zupt = 1;

		right_zupt_extension_time--;
	}

	//һڵĿ
	setData(right_shoes_data_vector, time_stamp, right_pos[0] * 0.001f, right_pos[1] * 0.001f, right_pos[2] * 0.001f,
		right_att[0] * 0.0001f, right_att[1] * 0.0001f, right_att[2] * 0.0001f, right_zupt, rssi);

	setData(left_shoes_data_vector, time_stamp, left_pos[0] * 0.001f, left_pos[1] * 0.001f, left_pos[2] * 0.001f,
		left_att[0] * 0.0001f, left_att[1] * 0.0001f, left_att[2] * 0.0001f, left_zupt, rssi);

	//ݣȫλ
	calGlobalPos(right_shoes_data_vector, right_step_data_vector, right_global_pos, right_heading, 0, RIGHT_FOOT);

	calGlobalPos(left_shoes_data_vector, left_step_data_vector, left_global_pos, left_heading, 0, LEFT_FOOT);

	//ͨٶȡԼvectorѾ˿еλжʱʱʱжϵЧʱΪ˵ȺʵRSSI
	if (left_step_data_vector.size() > 5 && left_step_data_vector.front().zupt == 1 && left_step_data_vector.back().zupt == 1)
	{
		//if (unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left) && press_valid)
		if (unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left) || left_front_press & 0x01)
		{
			left_zupt_extension_time = 20;

			left_cmd_wait_time = time_stamp;

			left_init = 1;

		}

	}

	if (right_step_data_vector.size() > 5 && right_step_data_vector.front().zupt == 1 && right_step_data_vector.back().zupt == 1)
	{
		//if (unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right) && press_valid)
		if (unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right) || right_front_press & 0x01)
		{
			right_zupt_extension_time = 20;

			right_cmd_wait_time = time_stamp;

			right_init = 1;

		}

	}

	//std::cout << left_acc[0] << ", " << left_acc[1] << ", " << left_acc[2] << std::endl;
	setPolarAccUnzupt(max_acc_unzupt_left, min_acc_unzupt_left, left_acc, left_zupt);

	setPolarAccUnzupt(max_acc_unzupt_right, min_acc_unzupt_right, right_acc, right_zupt);
	

	//
	memset(result, -1, 4 * sizeof(int));


	//ж˫Ŵصʱ, rssi < 23 λȻҲû취
	//rssiӳйõ

	if (left_init == 1 && time_stamp - left_cmd_wait_time >= 9 && time_stamp - left_cmd_wait_time < 30)
	{
		std::cout  << " left_att[1] : " << left_att[1] << " right_att[1] : " << right_att[1] << std::endl;
		if (right_init == 1)
		{
			if (rssi < rssi_threshold)
			{
				result[0] = MOTION_BOTH_ON_FLOOR_CLOSE;

				std::cout << " MOTION_BOTH_ON_FLOOR_CLOSE " << rssi <<  ", " << " Ͻ"  <<std::endl;
			}
			else
			{
				result[0] = MOTION_BOTH_ON_FLOOR_OPEN;

				std::cout << " MOTION_BOTH_ON_FLOOR_OPEN "<< rssi << ", "  << " "<<std::endl;
			}

		}
		else
		{
			std::cout << "pitch_reference_val : " << pitch_reference_val << endl;
			if (abs(left_att[1] - right_att[1] - pitch_reference_val) < 2000)
			{
				if (rssi < rssi_threshold)
				{
					result[0] = MOTION_BOTH_ON_FLOOR_CLOSE;

					std::cout << " MOTION_BOTH_ON_FLOOR_CLOSE " << rssi << ", " << " Ͻ" << std::endl;
				}
				else
				{
					result[0] = MOTION_BOTH_ON_FLOOR_OPEN;
					std::cout << " MOTION_BOTH_ON_FLOOR_OPEN " << rssi << ", " << " " << std::endl;
				}

				right_shoes_data_vector.pop_front();
				right_step_data_vector.pop_front();
			}
			else
			{
				result[0] = MOTION_LEFT_ON_FLOOR;
				std::cout << " MOTION_LEFT_ON_FLOOR " << time_stamp << ", " << " 󵥽" << std::endl;
			}
		
		}

		right_init = 0;
		right_cmd_wait_time = 0;
		left_init = 0;
		left_cmd_wait_time = 0;


	}
	else if (right_init == 1 && time_stamp - right_cmd_wait_time >= 9 && time_stamp - right_cmd_wait_time < 30)
	{
		std::cout  << " left_att[1] : " << left_att[1] << " right_att[1] : " << right_att[1] << std::endl;
		if (left_init == 1)
		{
			if (rssi < rssi_threshold)
			{
				result[0] = MOTION_BOTH_ON_FLOOR_CLOSE;

				std::cout << " MOTION_BOTH_ON_FLOOR_CLOSE "  << " "<< rssi << ", " << " Ͻ" << std::endl;
			}
			else
			{
				result[0] = MOTION_BOTH_ON_FLOOR_OPEN;
				std::cout << " MOTION_BOTH_ON_FLOOR_OPEN "  << " " << rssi << ", "  << " "<<std::endl;
			}

			left_init = 0;

			left_cmd_wait_time = 0;
		}
		else
		{
			std::cout << "pitch_reference_val : " << pitch_reference_val << endl;
			if (abs(left_att[1] - right_att[1] - pitch_reference_val) < 2000)
			{
				if (rssi < rssi_threshold)
				{
					result[0] = MOTION_BOTH_ON_FLOOR_CLOSE;

					std::cout << " MOTION_BOTH_ON_FLOOR_CLOSE " << rssi << ", " << " Ͻ" << std::endl;
				}
				else
				{
					result[0] = MOTION_BOTH_ON_FLOOR_OPEN;
					std::cout << " MOTION_BOTH_ON_FLOOR_OPEN " << rssi << ", " << " " << std::endl;
				}

				left_shoes_data_vector.pop_front();
				left_step_data_vector.pop_front();
			}
			else
			{
				result[0] = MOTION_RIGHT_ON_FLOOR;
				std::cout << " MOTION_RIGHT_ON_FLOOR " << time_stamp << ", " << "ҵ" << std::endl;
			}
			
		}
		right_init = 0;
		right_cmd_wait_time = 0;
		left_init = 0;
		left_cmd_wait_time = 0;

	}

	if (right_init == 1 && time_stamp - right_cmd_wait_time >= 30)
	{
		right_init = 0;
		right_cmd_wait_time = 0;
	}

	if (left_init == 1 && time_stamp - left_cmd_wait_time >= 30)
	{
		left_init = 0;
		left_cmd_wait_time = 0;
	}


	if (result[0] != -1)
	{
		addMotionCount(JUMP_COUNT);
	}

}