

#ifndef  PUBLIC_SDK_MOTION
#define  PUBLIC_SDK_MOTION

#define LEFT_FOOT 1
#define RIGHT_FOOT 2

#include<iostream>
#include<vector>
#include<deque>

#include "pub.h"
#include "MotionCount.h"

using namespace std;

struct shoes_data_cell {
	//ЬӴʱ
	int time_stamp;

	//Ьӵǰλ
	float pos_x;
	float pos_y;
	float pos_z;

	//Ьӵ̬
	float heading;
	float pitch;
	float roll;

	int zupt;

	int rssi;

};

class PublicSDKMotion : public MotionCount {
public:

	virtual void setData(deque<shoes_data_cell>& shoes_data_vector, int time_stamp, float pos_x, float pos_y, float pos_z, float heading, float pitch, float roll, int zupt, int rssi);

	virtual void Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press,int right_back_press,
		int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
		int jump, int down, int rssi);

	virtual void getResult(int* dec);

	virtual float getGamePos(int left_or_right, int index);


};

#endif 