#pragma once

#ifndef __ruins_explore_h__
#define __ruins_explore_h__

#include "pub.h"

class RuinsExplore
{
public:

	RuinsExplore();

	void Process(int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_press,
		int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_press,
		int jump, int down, int girl_shoes);

	int getResultJump(int jump);

	int getAccStatus(int zupt, int* acc, int* max_acc, int* min_acc);

	void getResult(int* dec);

private:

	int result[4];

	int last_jump;

	int left_zupt;

	int right_zupt;


	int last_jump_time;

	int right_acc_status;

	int left_acc_status;

	int right_acc_max[3];

	int left_acc_max[3];

	int right_acc_min[3];

	int left_acc_min[3];

};



#endif