#ifndef _jumpH5_H
#define _jumpH5_H

#include "pub.h"

class jumpH5 {
public:
	void Process(int* right_pos, int* right_att, int* right_acc, int right_press, int right_zupt,
		int* left_pos, int* left_att, int* left_acc, int left_press, int left_zupt,
		int jump, int time_s, int rssi);

	void  getResult(int* result);
private:

	int last_right_pos[3];
	int last_left_pos[3];

	unsigned int left_press_window[10];
	unsigned int right_press_window[10];

	int left_press_zupt_wait = 0;
	int right_press_zupt_wait = 0;

	int can_detect_acc_zero_left = 0;

	int can_detect_acc_zero_right = 0;

	int last_right_zupt;
	int last_left_zupt;

	int left_wait_time = 0;
	int right_wait_time = 0;

	int left_pos_wait[3];
	int right_pos_wait[3];

	int report_tag = 0;

	int next_result_wait = 0;

	int not_on_floor_time = 0;
	
	int H5_result[4] = { 0,0,0,0 };

	unsigned int H5_time_stamp = 0;

	unsigned int last_result_time_stamp = 0;
	
	int H5_receive_time = -256;



};
#endif