
#include <iostream>
#include<deque>

#include "pub.h"

#include "online_motion.h"

#define RESULT_LEN 10

using namespace std;

struct shoes_data_cell {
	//ЬӴʱ
	int time_stamp;

	//Ьӵǰλ
	float pos_x;
	float pos_y;
	float pos_z;

	//Ьӵ̬
	float heading;
	float pitch;
	float roll;

	int zupt;

	int rssi;

};

/*
* ýӿ࣬ 븴óȡ
*/
class PublicInterface
{
public :
	int result[RESULT_LEN]; //صֻ

	float left_global_pos[3];//Ϸȫλ
	float right_global_pos[3];

	int max_acc_unzupt_left[3];//¼ʱٶȵֵСֵ
	int min_acc_unzupt_left[3];

	int max_acc_unzupt_right[3];
	int min_acc_unzupt_right[3];

	online_motion extract_motion; //Ĳ䶯,סЬ洦ӦÿϷ

	PublicInterface() {
		memset(result, 0, RESULT_LEN * sizeof(int));

		memset(left_global_pos, 0, 3 * sizeof(float));

		memset(right_global_pos, 0, 3 * sizeof(float));
	};

	void getResult(int* dec); //صֻݽӿ

	void setData(deque<shoes_data_cell>& shoes_data_vector, int time_stamp, float pos_x, float pos_y, float pos_z,
		float heading, float pitch, float roll, int zupt, int rssi);//еݵshoes_data_vectorУ ͷβʱ

	/*
	* ȫλõͨ ЬӴĿshoes_data_vectorΪתĿ
	* main_heading ķתЬӵĳ
	* extra_heading ǰЬӳĹ켣ݣתһתŹ峯λ
	*/
	void calGlobalPos(deque<shoes_data_cell>& shoes_data_vector, deque<shoes_data_cell>& step_data_vector, float* global_pos, 
		float main_heading, float extra_heading, int LEFT_OR_RIGHT);

	/*
	* ȡȫλõͨ, pythonűbugʱ򣬲鿴Ϸڵȫλûз
	*/
	float getGamePos(int left_or_right, int index);


	/*
	* ѰҷǴʱٶȺСٶ
	*/
	void setPolarAccUnzupt(int* max_acc, int* min_acc, int* acc, int zupt);

	/*
	* жϿй켣мٶȵֵСծ
	*/
	bool unzuptValid(int* max_acc, int* min_acc);

	/*
	* Сrssi_threshźŵĸۼƵzupt_countƵǰЬӵķԼglobal_posΪ0
	*/
	void resetZerosPointByRssi(int zupt, int zupt_count_thresh, int& zupt_count, int& has_init, float heading, float& rotate_heading, int rssi, int rssi_thresh,  float* global_pos);


};